public class Ambulance
{
    private int id;

    private boolean available;
    private Patient patient;
    private boolean[][] cityRoad;
    private PathFinder getPath;

    private boolean move;

    private int currentX;
    private int currentY;

    private int homeX;
    private int homeY;
    
    private String directions = "";

    private byte status;

    private final byte PICK_UP = 0;
    private final byte DROP_OFF = 1;
    private final byte TO_STATION = 2;
    private final byte DRIVING = 3;
    private final byte NOTHING = 4;

    public Ambulance(int x, int y, int id, boolean[][] cityRoad)
    {
        this.id = id;
        getPath = new PathFinder(cityRoad);
        this.cityRoad = cityRoad;
        available = true;
        homeX = x;
        homeY = y;
        currentX = x;
        currentY = y;
        status = NOTHING;
    }

    public void simulate()
    {

        if (directions.length() > 0) {
            moveTo();
        }

        if ((directions.length() == 0) && (status != NOTHING)) {
            atDestination();
        }
    }


    public boolean isAvailable()
    {
        return available;
    }
    
    public int getX()
    {
        return currentX;
    }
    
    public int getY()
    {
        return currentY;
    }
    
    private void moveTo()
    {
        //look at next thing in string and then delete it
        char next = directions.charAt(0);
        switch (next) {
            case 'R':
                currentX++;
                break;
            case 'L':
                currentX--;
                break;
            case 'U':
                currentY--;
                break;
            case 'D':
                currentY++;
        }
        directions = directions.substring(1, directions.length());
    }


    private void atDestination()
    {
        switch (status) {
            case PICK_UP:
                //System.out.println(id+"picked up");
                patient.pickUp();
                goToHospital();
                break;
            case DROP_OFF:
                //System.out.println(id+"Drop Off");
                //System.out.println(id+"Goin to Station");
                available = true;
                //remove patient
                patient = null;
                goToStation();
                break;
            case TO_STATION:
                //System.out.println(id+"at home");
                status = NOTHING;
                break;
            case NOTHING:
                break;
            default:
                //System.out.println(id+"whats wrong");
        }
    }



    public void pickUp(Patient patient)
    {
        //System.out.print(id+"pickin up patient************");
        status = PICK_UP;
        this.patient = patient;
        available = false;
        int destinationX = patient.getX();
        int destinationY = patient.getY();
        System.out.println(destinationX + " " + destinationY);
        directions = getPath.findPath(currentX, currentY, destinationX, destinationY);
    }

    private void goToStation()
    {
        status = TO_STATION;
        directions = getPath.findPath(currentX, currentY, homeX, homeY);
    }
    
    private void goToHospital()
    {
        status = DROP_OFF;
        //need way to find hospital to drop off at??
        directions = getPath.findPath(currentX, currentY, 8, 9);
    }


}


























