import java.util.Random;
import java.util.ArrayList;


public class AmbulanceStation
{
    private Random randomNumber = new Random();

    private boolean[][] cityRoad;

    private int totalAmbulances;

    private ArrayList<Ambulance> ambulances;
    
    private int locationX;
    private int locationY;



    public AmbulanceStation(int x, int y, boolean[][] cityRoad)
    {
        this.cityRoad = cityRoad;
        totalAmbulances = randomNumber.nextInt(2) + 1;
        ambulances = new ArrayList<Ambulance>();
        locationX = x;
        locationY = y;

        for (int i = 0; i < totalAmbulances; i++) {
            ambulances.add(new Ambulance(locationX ,locationY, i, cityRoad));
        }
    }

    public void simulate() {
        for (Ambulance a : ambulances) {
            a.simulate();
        }
    }

   /**
    * Returns a ArrayList of avaiable ambulances.
    * If no ambulances avaiable then returns null.
    *
    * @return               an ArrayList of avaiable ambulances or null
    */
    public ArrayList<Ambulance> freeAmbulances()
    {
        ArrayList<Ambulance> available = new ArrayList<Ambulance>();

        for (Ambulance current : ambulances) {
            if (current.isAvailable()){
                available.add(current);
            }
        }
        return available;
    }


    public ArrayList<Ambulance> getAmbulances()
    {
        return ambulances;
    }
}