import java.util.Random;
import java.util.ArrayList;

public class Test
{
    private Random rand = new Random();
    private boolean[][] city;
    ArrayList<Ambulance> all = new ArrayList<Ambulance>();
    ArrayList<Patient> p = new ArrayList<Patient>();
    int count = 0;
    Dispatcher d;

    public static void main(String args[])
    {
        Test test = new Test();
        test.run();
    }


    public void run()
    {
        makeCity();
        d = new Dispatcher(city);
        d.newStation(4,12);
        d.newStation(0,0);
        all = d.getAllAmbulances();

        for(int i = 0; i < 100000; i++) {
            d.simulate();
            printOut();
            System.out.println(i);
            manySec(1);
            if (rand.nextInt(100) > 96) {
                add();
            }
        }
    }

    public static void manySec(long s) {
        try {
            Thread.currentThread().sleep(s * 500);
        }
        catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
    
    public void add() {
        int tempX;
        int tempY;
        do {
            tempX = rand.nextInt(15);
            tempY = rand.nextInt(15);
        } while (!city[tempX][tempY]);

        p.add(new Patient(tempX, tempY));
        d.pickUpRequest(p.get(count));
        count++;
    }

    public void printOut()
    {
        byte[][] intCity = new byte[15][15];
        makeIntCity(intCity);


        intCity[4][12] = 2;
        intCity[0][0] = 2;
        intCity[8][9] = 3;


        for (Patient pa : p) {
            if (!pa.getOk()) {
                int x = pa.getX();
                int y = pa.getY();
                intCity[x][y] = 5;
            }
        }
        for (Ambulance a : all) {
            int x = a.getX();
            int y = a.getY();
            intCity[x][y] = 4;
        }

        String s = "\n\n\n\n\n\n\n\n";

        for (int y = 0; y < 15; y++)
        {
            for (int x = 0; x < 15; x++)
            {
                if(intCity[x][y] == 1) {
                    s+="+ ";
                }
                else if(intCity[x][y] == 2) {
                    s+="S ";
                }
                else if(intCity[x][y] == 3) {
                    s+="H ";
                }
                else if(intCity[x][y] == 4) {
                    s+="A ";
                }
                else if(intCity[x][y] == 5) {
                    s+="P ";
                }
                else {
                    s+="  ";
                }
            }
            s+="\n";
        }
        System.out.println(s);
    }



    
    public void makeCity()
    {
        city = new boolean[15][15];

        for (int y = 0; y < 15; y++)
        {
            for (int x = 0; x < 15; x++)
            {
                city[x][y] = false;
            }
        }
        
        for (int y = 0; y < 15; y++) {
            city[0][y] = true;
            city[4][y] = true;
            city[9][y] = true;
            city[14][y] = true;

        }

        for (int x = 0; x < 15; x++)
        {
            city[x][0] = true;
            city[x][3] = true;
            city[x][7] = true;
            city[x][10] = true;
            city[x][14] = true;
        }
        
        city[4][4] = false;
        city[4][5] = false;
        city[4][6] = false;
        city[9][8] = false;
        city[9][9] = false;
        city[9][11] = false;
        city[10][3] = false;
        city[11][3] = false;
        city[4][13] = false;
        city[8][9] = true;
        city[8][8] = true;


    }
    

    public void makeIntCity(byte[][] a)
    {

        for (int y = 0; y < 15; y++)
        {
            for (int x = 0; x < 15; x++)
            {
                a[x][y] = 0;
            }
        }
        
        for (int y = 0; y < 15; y++) {
            a[0][y] = 1;
            a[4][y] = 1;
            a[9][y] = 1;
            a[14][y] = 1;

        }

        for (int x = 0; x < 15; x++)
        {
            a[x][0] = 1;
            a[x][3] = 1;
            a[x][7] = 1;
            a[x][10] = 1;
            a[x][14] = 1;
        }
        
        a[4][4] = 0;
        a[4][5] = 0;
        a[4][6] = 0;
        a[9][8] = 0;
        a[9][9] = 0;
        a[9][11] = 0;
        a[10][3] = 0;
        a[11][3] = 0;
        a[4][13] = 0;
        a[8][9] = 1;
        a[8][8] = 1;

        

    }

}